#!/bin/sh /etc/rc.common
-# Copyright (C) 2006-2009 OpenWrt.org
+# Copyright (C) 2006-2010 OpenWrt.org
# Copyright (C) 2006 Carlos Sobrinho
NAME=dropbear
PROG=/usr/sbin/dropbear
START=50
+STOP=50
PIDCOUNT=0
EXTRA_COMMANDS="killclients"
EXTRA_HELP=" killclients Kill ${NAME} processes except servers and yourself"
local passauth
config_get_bool passauth "${section}" PasswordAuth 1
[ "${passauth}" -eq 0 ] && nopasswd=1
- # B) listen port
+ # B) listen interface and port
local port
+ local interface
+ local address
config_get port "${section}" Port
+ config_get interface "${section}" Interface
+ config_get address "${interface}" ipaddr
+ port="${address:+${address}:}${port}"
# C) banner file
local bannerfile
- config_get bannerfile ${section} BannerFile
- [ -f $bannerfile ] || bannerfile=''
+ config_get bannerfile "${section}" BannerFile
+ [ -f "$bannerfile" ] || bannerfile=''
# D) gatewayports
local gatewayports
config_get_bool gatewayports "${section}" GatewayPorts 0
[ "${gatewayports}" -eq 1 ] || gatewayports=''
+ # E) root password authentication
+ local norootpasswd
+ local rootpassauth
+ config_get_bool rootpassauth "${section}" RootPasswordAuth 1
+ [ "${rootpassauth}" -eq 0 ] && norootpasswd=1
+ local rootloginallowed
+ local norootlogin
+ config_get_bool rootloginallowed "${section}" RootLogin 1
+ [ "${rootloginallowed}" -eq 0 ] && norootlogin=1
# concatenate parameters
local args
- args="${nopasswd:+-s }${port:+-p ${port} }${bannerfile:+-b $bannerfile }${gatewayports:+-a }-P /var/run/${NAME}.${PIDCOUNT}.pid"
+ args="${nopasswd:+-s }${norootpasswd:+-g }${norootlogin:+-w }${port:+-p ${port} }${bannerfile:+-b $bannerfile }${gatewayports:+-a }-P /var/run/${NAME}.${PIDCOUNT}.pid"
# execute program and return its exit code
[ "${verbosed}" -ne 0 ] && echo "${initscript}: section ${section} starting ${PROG} ${args}"
[ -s /etc/dropbear/dropbear_rsa_host_key -a \
-s /etc/dropbear/dropbear_dss_host_key ] || keygen
+ include /lib/network
+ scan_interfaces
config_load "${NAME}"
config_foreach dropbear_start dropbear
}
local pidfile
for pidfile in `ls /var/run/${NAME}.*.pid`
do
- start-stop-daemon -K -s KILL -p "${pidfile}" -n "${NAME}" >/dev/null
+ start-stop-daemon -q -K -s KILL -p "${pidfile}" -n "${NAME}"
rm -f "${pidfile}"
done
[ -z "${pidfile}" ] && echo "${initscript}: no pid files, if you get problems with start then try killclients"
[ "${pid}" -eq 0 ] && break
# check if client connection
- ps | grep -e "^[ ]*${pid} " | grep "${PROG}" >/dev/null
- if [ $? -eq 0 ]
- then
+ grep -F -q -e "${PROG}" "/proc/${pid}/cmdline" && {
append ignore "${pid}"
break
- fi
+ }
done
# get all server pids that should be ignored
local skip
for pid in `pidof "${NAME}"`
do
- # check if correct program
- ps | grep -e "^[ ]*${pid} " | grep "${PROG}" >/dev/null
- [ $? -ne 0 ] && continue
+ # check if correct program, otherwise process next pid
+ grep -F -q -e "${PROG}" "/proc/${pid}/cmdline" || {
+ continue
+ }
# check if pid should be ignored (servers, ourself)
skip=0